unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,


  mORMot,
  SynDB,          //TQuery
  SynTable,       //SynDBVCL, mORMotMidasVCL,
  SynDBRemote,    // Remote Access
  SynCommons
  //SynDBDataset,
  //SynDBMidasVCL
  //SynDBMidasVCLExtra

  ;


type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  LCnt: TSQLDBConnectionProperties;


implementation

{$R *.lfm}

{ TForm1 }

function fQueryHttpSQLConnection  ( const sHost, sPort, sDb, sUser, sPass: String ): TSQLDBConnectionProperties;
var
  sHostPort: String;
  //LCnt: TSQLDBConnectionProperties;
begin

  Result := Nil;
  sHostPort := sHost + ':' + sPort;
  try
    Result := TSQLDBWinHTTPConnectionProperties.Create( sHostPort , sDb, sUser, sPass );
    if ( Result<>nil ) then
      Result.VariantStringAsWideString := true;
  except on E: Exception do
    begin
      MessageDlg('HttpReq', 'Error connecting to Server'+ LineEnding+LineEnding+E.Message, mtWarning, [mbOK], 0);
      //raise Exception.Create('Error connecting to HttpServer: ' + LineEnding + E.Message);
      Result := Nil;
    end;
  end;
  //if LCnt = nil then
  //  MessageDlg('', '', mtWarning, [mbOK], 0);
     //raise exception.Create( 'Error connecting to server... ' );
  //Result := LCnt;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  iErr: Integer;
begin

  //LCnt := fQueryHttpSQLConnection  ( '127.0.0.1', '7443' , 'medic1', 'user', 'pass' );
  //Result := Nil;
  //sHostPort := sHost + ':' + sPort;
  iErr := 0 ;
  try
    try
      LCnt := TSQLDBWinHTTPConnectionProperties.Create( '127.0.0.1:7443' , 'mediq1', 'user' , 'pass' );
      if ( LCnt<>nil ) then
        LCnt.VariantStringAsWideString := true;
    except on E: Exception do
      begin
        iErr := -1;
        //LCnt := Nil;
        MessageDlg('HttpReq', 'Error connecting to Server'+ LineEnding+LineEnding+E.Message, mtWarning, [mbOK], 0);
        //  //raise Exception.Create('Error connecting to HttpServer: ' + LineEnding + E.Message);
        FreeAndNil(LCnt);
      end;
    end;
  finally
    if iErr<>0 then
      FreeAndNil(LCnt);
  end;


end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  if LCnt<>nil then
    FreeAndNil(LCnt);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LCnt := Nil;
	{$if declared(useHeapTrace)}
		Label1.Caption := 'heaptrc is used '; // +  useHeaptrace;
	{$else}
		Label1.Caption := 'No heaptrc is used ';
	{$endIf}

end;

end.

